unit paranoia;

INTERFACE

procedure go;

IMPLEMENTATION

uses main,CRT,OP386,Anima13,Mode13,math,Engine3D,colors,keys,MyDOS,MyMidas;

procedure go;
const
	SPEED=1;

	TOTAL=4;
	name:array[0..TOTAL] of string=
		('PARANOIA','HUECO','4EP97','7EP97','8EP97');

	wait:integer=128;

	pantallas:array[0..5] of record
		name:string[8];
		p:^byte;
		pal:^Tpal;
		stop:boolean;
	end=
		((name:'X'),
		 (name:'TB'),
		 (name:'MAS'),
		 (name:'CARETO'),
		 (name:'MJB'),
		 (name:'LEFFY'));

var
	nc,a,a1,n,m,f,l:word;
	bola,o:P3D;
	c:array[0..TOTAL] of Tpal;
	MoreNear:array[0..TOTAL] of integer;
	s:array[0..TOTAL,0..255] of byte;
	h:array[0..TOTAL] of PTexture;
	i1,i2,orbit1,orbit2,ai1,ai2,ai3,
	b,d,
	x,y:integer;
	save:Tmode;
	ocp:boolean;
	pl:PMapLight;
	scene:Tscene;
	EnvMap:PTexture;
	trn:PTransparency;
	light:TLight;
	_TMP_,
	hl:integer;
	cam:TCamera;

begin
	StartCrono;
	SetTransferMode(COPY_BLUR);
	SetSyncro(FALSE);

	NewScene(scene,MAX_FACES_IN_SCENE);

	for a:=0 to high(pantallas) do with pantallas[a] do
		begin
			GetMem(p,vRAMSize);
			GetMem(pal,SizeOf(Tpal));
			if not LoadIMG(name,p,pal^) then fError(name+'.IMG');
			pal^[0]:=black;
		end;

	if not LoadIMG('FLOOR24',PBackPage,c[0]) then Ferror('FLOOR24.IMG');
	_TMP_:=TotalSpr+1;
	SprInfo^[_TMP_].PSprite:=pointer(PBackPage);
	SprInfo^[_TMP_].width:=320;
	SprInfo^[_TMP_].height:=200;

	if not LoadTexture('ORO',EnvMap,c[0]) then Ferror('ORO.TEX');
	for n:=0 to TOTAL do
		if not LoadTexture(name[n],h[n],c[n]) then Ferror(name[n]+'.TEX');
	if not LoadMapLight(pl,'PARANOIA') then Ferror('PARANOIA.LGT');
	if not LoadTransparency(trn,'PARANOIA') then fError('PARANOIA.TRN');
	SetUnColor(ball,ALL_CHILDS,GetNearColor(white,c[0]));

	if not Load3D(o,'PINCHO2') then Ferror('PINCHO2.3DN');
	SetEnvMap(o,ALL_CHILDS,EnvMap);
	SetRenderType(o,ALL_CHILDS,_TEXTURE_ENVMAP_);
	SetTexture(o,ALL_CHILDS,h[0]);
	SetTransparency(o,ALL_CHILDS,trn);
	SetMapLight(o,ALL_CHILDS,pl);

	for n:=TOTAL Downto 0 do
		begin
			SetShade(0.9,c[n]);
			move(ShadeTable,s[n],SizeOf(ShadeTable));
			MoreNear[n]:=GetNearColor(white,c[n]);
		end;

	if not Load3D(bola,'PINCHO2') then fError('PINCHO.3DN');
	SetRenderType(bola,ALL_CHILDS,_GOURAUD_TRANSPARENT_);
	SetMapLight(bola,ALL_CHILDS,pl);
	SetTransparency(bola,ALL_CHILDS,trn);
	UnScaleCoordinates(bola,ALL_CHILDS,10);
	bola^.world.z:=250;

	hl:=NewLight(scene,_FOCUS_);
	light.from.x:=-50;
	light.from.y:=50;
	light.from.z:=-100;
	light.where.z:=-500;

	ResetCamera(cam);

	orbit1:=256;orbit2:=128;
	i1:=2;i2:=1;
	a:=random(DEG)+1;
	a1:=random(DEG);
	ai1:=random(5)+1;
	ai2:=random(5);
	ai3:=random(5)+1;
	nc:=0;
	ocp:=FALSE;

	InitDifumine(0,255,c[0]);
	SkipFrames:=StartFrame;
	inc(MyFrames);
	repeat
		SetCamera(scene,cam);
		sf:=GetSemaphore(13);
		difumine;

		b:=MyFrames mod wait;
		if (b=0) and (not ocp) then
			begin
				wait:=aleatorio(3,64);
				if random(4)=0 then
					SetRenderType(o,ALL_CHILDS,_TEXTURE_ENVMAP_)
				else
					SetRenderType(o,ALL_CHILDS,Trender(random(ord(high(Trender)))));

				case random(5) of
					0:SetTransferMode(COPY_GRANULATE);
					1:SetTransferMode(COPY_BLUR);
					2:SetTransferMode(SHADE_BLUR);
					3:SetTransferMode(HALF_COPY);
					4:SetTransferMode(COPY_MESH);
				end;

				n:=random(TOTAL+1);
				SetTexture(o,ALL_CHILDS,h[n]);
				InkAllRGB(0,255,c[n]);
				SetUnColor(ball,ALL_CHILDS,MoreNear[n]);
				move(s[n],ShadeTable,SizeOf(ShadeTable));

				i1:=aleatorio(0,10);
				i2:=aleatorio(0,10);
				orbit1:=1 shl (random(7)+2);
				orbit2:=1 shl (random(7)+2);
				ai1:=random(5);
				ai2:=random(5);
				ai3:=random(5);
			end;

		if GetTransferMode<>SHADE_BLUR then PutScaleSpriteClipped(_TMP_,SPEED*-MyFrames,SPEED*round(-MyFrames*0.8),
																																		320+(SPEED*MyFrames),200+(SPEED*round(MyFrames*0.8)));
		PutAll3D(scene,o);
		MoveBall(scene);

		with bola^ do
			begin
				angle.caida:=angle.caida+1;
				if angle.caida>DEG then angle.caida:=angle.caida-DEG;

				angle.balanza:=angle.balanza-2;
				if angle.balanza>DEG then angle.balanza:=angle.balanza+DEG;

				angle.deriva:=angle.deriva+3;
				if angle.deriva>DEG then angle.deriva:=angle.deriva-DEG;

				light.where.x:=world.x*8;light.where.y:=world.y*8;light.where.z:=-world.z*3;
				SetLight(scene,hl,light);
			end;
		Put3D(scene,bola,DADDY);
		RenderScene(scene);

		rectangle(0,0,XMAX,5,0);
		rectangle(0,195,XMAX,200,0);

		DrawV(0,0,YMAX,0);
		DrawV(XMAX,0,YMAX,0);

		for f:=1 to SkipFrames do with o^ do
			begin
				angle.caida:=angle.caida+ai1;
				if angle.caida>DEG then angle.caida:=angle.caida-DEG;

				angle.balanza:=angle.balanza+ai2;
				if angle.balanza>DEG then angle.balanza:=angle.balanza-DEG;

				angle.deriva:=angle.deriva+ai3;
				if angle.deriva>DEG then angle.deriva:=angle.deriva-DEG;

				inc(a,i1);
				if a>DEG then
					dec(a,DEG)
				else
					if a<0 then inc(a,DEG);
				world.x:=orbit1*sin(a*RAD);

				inc(a1,i2);
				if a1>DEG then
					dec(a1,DEG)
				else
					if a1<0 then inc(a1,DEG);
				world.y:=orbit2*cos(a1*2*RAD);
				world.z:=ball^.world.z*2.5;

				bola^.world.x:=-world.x/8;
				bola^.world.y:=-world.y/8;
			end;

		if inkey[K_ESC] then halt;

		if ToFinish<500 then
			begin
				reduce(0,0,MoreNear[n]);
				if nc<25 then
					begin
						ocp:=TRUE;
						x:=MyFrames and 3;
						if x=7-1 then
							WhitePal
						else
							if x=0 then
								begin
									InkAllRGB(0,255,c[n]);
									inc(nc);
								end;
					end
				else
					ocp:=FALSE;

				x:=1;y:=0;
				for m:=1 to nc do
					begin
						if m mod 5=0 then
							begin
								inc(y);
								x:=0;
							end;
						CopyBitMap(x*64,y*40);
						inc(x);
					end;
			end;
		if b=wait-1 then
			begin
				repeat
					d:=random(high(pantallas)+1);
				until d<>3;
				move(pantallas[d].p^,PvRAM^,vRAMSize);
				InkAllRGB(0,255,pantallas[d].pal^);
			end;

		if d>=4 then
			begin
				save:=GetTransferMode;
				SetTransferMode(COPY);
			end;
		SkipFrames:=anima;
		if d>=4 then
			begin
				CRT.delay(50);
				SetTransferMode(save);
				d:=0;
			end;
	until ToFinish<100;

	SetSyncro(TRUE);
	SetTransferMode(NOP);
	BlackPal;
	move(pantallas[3].p^,VGA^,vRAMSize);
	DifumineToPalette(0,255,pantallas[3].pal^);
	CRT.delay(1500);
	DifumineToColor(0,255,blue);

	for a:=0 to high(pantallas) do with pantallas[a] do
		begin
			FreeMem(p,vRAMSize);
			FreeMem(pal,SizeOf(Tpal));
		end;
	FreeMapLight(pl);
	FreeTransparency(trn);
	FreeLight(scene,hl);
	Free3D(o);
	Free3D(bola);
	FreeScene(scene);
	for n:=0 to TOTAL do FreeTexture(h[n]);
	FreeTexture(EnvMap);
end;

end.